/**
 *  This file is part of RegCEl.
 *
 *  Copyright (c) 2012 Yunior Barcel Chvez barceloch@gmail.com
 *
 *  RegCEl is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  RegCEl is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with RegCEl.  If not, see <http://www.gnu.org/licenses/>.
 *
 **/
#ifndef  REGCElWIDGET_H
#define  REGCElWIDGET_H

#include <QWidget>
#include<QtSql/QSqlTableModel>
#include <QModelIndex>
QT_BEGIN_NAMESPACE
class QLCDNumber;
class QCalendarWidget;
class QCheckBox;
class QComboBox;
class QDate;
class QDateEdit;
class QGridLayout;
class QGroupBox;
class QLabel;
class QSpacerItem;
class QSqlTableModel;
class QSqlRelationalTableModel;
class QTableView;
class QPushButton;
QT_END_NAMESPACE

namespace View
{
    namespace Management
    {


class RegistModel;

class RegCEl : public QWidget
{
    Q_OBJECT

public:
    RegCEl(QWidget *parent = 0);
    ~RegCEl();

private slots:
   void rowSelectionChangedOnRegistsTableView();
   void addRegist();
   void modRegist();
   void delRegist();

private:
    void createConnections();
    void createRegistWidgets();
    void createDateGroupBox();
    void createDetailsGroupBox();
    void createRegistGroupBox();
    bool verifyDeleteRegist();

    QGroupBox *date_GroupBox;
    QGridLayout *date_Layout;
    QCalendarWidget *calendar;

    QGroupBox *detailsGroupBox;
    QLabel *lb_lect_inicial;
    QLabel *lb_lect_final;
    QLabel *lb_kw_h;
    QLabel *lb_importe;
    //QLabel *lb_aprox_men;
    QLabel *importe_lb;
    //QLabel *aprox_men_lb;

    QLCDNumber *lect_inicial;
    QLCDNumber *lect_final;
    QLCDNumber *kw_h;


    QGroupBox *registGroupBox;
    QTableView *_registsTableView;

    RegistModel *_registModel;

    QPushButton *_addRegistButton;
    QPushButton *_modRegistButton;
    QPushButton *_delRegistButton;
    QPushButton *_printButton;

    /*QSqlDatabase *database;
    QTableView *regist_View;
    QSqlTableModel *regist_Model;*/

};
}
}
#endif // REGCElWIDGET_H
