/**
 *  This file is part of RegCEl.
 *
 *  Copyright (c) 2012 Yunior Barcel Chvez barceloch@gmail.com
 *
 *  RegCEl is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  RegCEl is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with RegCEl.  If not, see <http://www.gnu.org/licenses/>.
 *
 **/

#ifndef REGISTMODEL_H
#define REGISTMODEL_H

#include <QAbstractTableModel>
#include <QList>

namespace Model
{
    namespace Domain
    {
        class Regist;
    }
}

namespace View
{
    namespace Management
    {
        class RegistModel : public QAbstractTableModel
        {
        public:
            RegistModel(QList<Model::Domain::Regist *> *regists, QObject *parent = 0)
                : QAbstractTableModel(parent), _regists(regists) {}
            ~RegistModel();
            QList<Model::Domain::Regist *> *regists();
            void setRegists(QList<Model::Domain::Regist *> *regists);
            bool insertRegist(int k, Model::Domain::Regist *regist);
            bool modifyRegist(int k);
            bool removeRegist(int k);
            int rowCount(const QModelIndex &parent) const;
            int columnCount(const QModelIndex &parent) const;
            QVariant data(const QModelIndex &index, int role) const;
            QVariant headerData(int section, Qt::Orientation orientation, int role) const;
        private:
            QList<Model::Domain::Regist *> *_regists;
        };
    }
}

#endif // RegistModel_H
