/**
 *  This file is part of RegCEl.
 *
 *  Copyright (c) 2012 Yunior Barcel Chvez barceloch@gmail.com
 *
 *  RegCEl is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  RegCEl is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with RegCEl.  If not, see <http://www.gnu.org/licenses/>.
 *
 **/
#ifndef REGITDIALOG_H
#define REGITDIALOG_H

#include <QDialog>

QT_BEGIN_NAMESPACE
class QGroupBox;
class QLabel;
class QLineEdit;
class QCheckBox;
class QTextEdit;
class QDateEdit;
class QTimeEdit;
class QLCDNumber;
class QPushButton;
QT_END_NAMESPACE

namespace Model
{
    namespace Domain
    {
        class Regist;
    }
}

namespace View
{
    namespace Management
    {
        class RegistDialog : public QDialog
        {
            Q_OBJECT
        public:
            RegistDialog(Model::Domain::Regist *regist, QWidget *parent = 0);
            void done(int result);
        private slots:
            void on_lectiLabel_textChanged();
            void on_lectfLabel_textChanged();
            void registModified(bool modified = true);
        private:
            void createWidgets();
            void createConnections();
            void loadRegist();
            void saveRegist();
            bool isSaveable();


            QGroupBox *_newRegistGbox;

            QLabel *_lectiLabel;
            QLineEdit *_lectiLineEdit;

            QLabel *_lectfLabel;
            QLineEdit *_lectfLineEdit;

            QLabel *_dateLabel;
            QDateEdit *_dateEdit;

            QLabel *_timeLabel;
            QTimeEdit *_timeEdit;

            QLabel *_kwhLabel;
            QLineEdit *_kwhLineEdit;

            QLabel *_importLabel;
            QLineEdit *_importLineEdit;

            QPushButton *_saveButton;
            QPushButton *_cancelButton;
            Model::Domain::Regist *_regist;
        };
    }
}

#endif
